<html>
<head>
<title>OGRE: OgrePolygon.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgrePolygon.h</h1><a href="OgrePolygon_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Copyright (c) 2006 Matthias Fink, netAllied GmbH &lt;matthias.fink@web.de&gt;                             </span>
<a name="l00009"></a>00009 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00010"></a>00010 <span class="comment"></span>
<a name="l00011"></a>00011 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00012"></a>00012 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00013"></a>00013 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00014"></a>00014 <span class="comment">version.</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00017"></a>00017 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00018"></a>00018 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00019"></a>00019 <span class="comment"></span>
<a name="l00020"></a>00020 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00021"></a>00021 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00022"></a>00022 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00023"></a>00023 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00024"></a>00024 <span class="comment"></span>
<a name="l00025"></a>00025 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00026"></a>00026 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00027"></a>00027 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00028"></a>00028 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00029"></a>00029 <span class="comment">*/</span>
<a name="l00030"></a>00030 <span class="preprocessor">#ifndef __Polygon_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#define __Polygon_H__</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>"</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00046"></a><a class="code" href="classOgre_1_1Polygon.html">00046</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Polygon.html" title="The class represents a polygon in 3D space.">Polygon</a>
<a name="l00047"></a>00047     {
<a name="l00048"></a>00048 
<a name="l00049"></a>00049     <span class="keyword">public</span>:
<a name="l00050"></a><a class="code" href="classOgre_1_1Polygon.html#72d1c26d937a8a3f8caad158c7d71745">00050</a>         <span class="keyword">typedef</span> std::vector&lt;Vector3&gt;                VertexList;
<a name="l00051"></a>00051 
<a name="l00052"></a><a class="code" href="classOgre_1_1Polygon.html#75ad4cca62e4f65b7f6007ee29c42644">00052</a>         <span class="keyword">typedef</span> std::multimap&lt;Vector3, Vector3&gt;     EdgeMap;
<a name="l00053"></a><a class="code" href="classOgre_1_1Polygon.html#e6e7019c9a29ef5eb95e6c063d355830">00053</a>         <span class="keyword">typedef</span> std::pair&lt; Vector3, Vector3&gt;        Edge;
<a name="l00054"></a>00054 
<a name="l00055"></a>00055     <span class="keyword">protected</span>:
<a name="l00056"></a><a class="code" href="classOgre_1_1Polygon.html#44797951e46517046987e8e73c86f060">00056</a>         VertexList      mVertexList;
<a name="l00057"></a><a class="code" href="classOgre_1_1Polygon.html#52453dc3845392de7cfb9516d92d8111">00057</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>         mNormal;
<a name="l00058"></a><a class="code" href="classOgre_1_1Polygon.html#371dbd706469fcd3a09e6cc9de307a31">00058</a>         <span class="keywordtype">bool</span>            mIsNormalSet;
<a name="l00061"></a>00061         <span class="keywordtype">void</span> updateNormal(<span class="keywordtype">void</span>);
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064     <span class="keyword">public</span>:
<a name="l00065"></a>00065         <a class="code" href="classOgre_1_1Polygon.html" title="The class represents a polygon in 3D space.">Polygon</a>();
<a name="l00066"></a>00066         ~<a class="code" href="classOgre_1_1Polygon.html" title="The class represents a polygon in 3D space.">Polygon</a>();
<a name="l00067"></a>00067         <a class="code" href="classOgre_1_1Polygon.html" title="The class represents a polygon in 3D space.">Polygon</a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Polygon.html" title="The class represents a polygon in 3D space.">Polygon</a>&amp; cpy );
<a name="l00068"></a>00068 
<a name="l00072"></a>00072         <span class="keywordtype">void</span> insertVertex(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vdata, <span class="keywordtype">size_t</span> vertexIndex);
<a name="l00076"></a>00076         <span class="keywordtype">void</span> insertVertex(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vdata);
<a name="l00077"></a>00077 
<a name="l00080"></a>00080         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getVertex(<span class="keywordtype">size_t</span> vertex) <span class="keyword">const</span>;
<a name="l00081"></a>00081 
<a name="l00085"></a>00085         <span class="keywordtype">void</span> setVertex(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vdata, <span class="keywordtype">size_t</span> vertexIndex);
<a name="l00086"></a>00086 
<a name="l00089"></a>00089         <span class="keywordtype">void</span> removeDuplicates(<span class="keywordtype">void</span>);
<a name="l00090"></a>00090 
<a name="l00093"></a>00093         <span class="keywordtype">size_t</span> getVertexCount(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00094"></a>00094 
<a name="l00097"></a>00097         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getNormal(<span class="keywordtype">void</span>);
<a name="l00098"></a>00098 
<a name="l00101"></a>00101         <span class="keywordtype">void</span> deleteVertex(<span class="keywordtype">size_t</span> vertex);
<a name="l00102"></a>00102 
<a name="l00107"></a>00107         <span class="keywordtype">void</span> storeEdges(EdgeMap *edgeMap) <span class="keyword">const</span>;
<a name="l00108"></a>00108 
<a name="l00111"></a>00111         <span class="keywordtype">void</span> reset(<span class="keywordtype">void</span>);
<a name="l00112"></a>00112 
<a name="l00115"></a>00115         <span class="keywordtype">bool</span> <a class="code" href="namespaceOgre.html#b426b0250db523190d60f4bfe0414499">operator == </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Polygon.html" title="The class represents a polygon in 3D space.">Polygon</a>&amp; rhs) <span class="keyword">const</span>;
<a name="l00116"></a>00116 
<a name="l00119"></a><a class="code" href="classOgre_1_1Polygon.html#0db7b835ad9015300d80253f0e7438cf">00119</a>         <span class="keywordtype">bool</span> <a class="code" href="namespaceOgre.html#9d8174300d9fd7b766d727c85e11a20f">operator != </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Polygon.html" title="The class represents a polygon in 3D space.">Polygon</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00120"></a>00120 <span class="keyword">        </span>{ <span class="keywordflow">return</span> !( *<span class="keyword">this</span> == rhs ); }
<a name="l00121"></a>00121 
<a name="l00124"></a>00124         <a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keyword">friend</span> std::ostream&amp; operator&lt;&lt; ( std::ostream&amp; strm, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Polygon.html" title="The class represents a polygon in 3D space.">Polygon</a>&amp; poly );
<a name="l00125"></a>00125 
<a name="l00126"></a>00126     };
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 }
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:54 2008
</p>
</body>
</html>
